-- by RivalBomb
-- V1.0

drivable_update = Drivable.update;

ECC = {};
ECC.currentSpeedLevel = 4;
ECC.lastSpeedLevel = 4;
ECC.speedLevelActivated = false;
ECC.maxSpeedLevel = 4;

ECCFunction = function(self, dt)
	if self.motor ~= nil and self:getIsActiveForInput(false) then
		if InputBinding.hasEvent(InputBinding.resetSpeed) then
			ECC.speedLevelActivated = false;
			
			local newSpeed = self.motor.maxForwardSpeed*3.6;
			self:setCruiseControlMaxSpeed(self.motor.maxForwardSpeed*3.6);
		end;
		if InputBinding.hasEvent(InputBinding.halfSpeed) then
			ECC.speedLevelActivated = false;
			
			local newSpeed = math.min(math.max(6, (self.motor.maxForwardSpeed*3.6)/3), 18);
			self:setCruiseControlMaxSpeed(newSpeed);
		end;
		if InputBinding.hasEvent(InputBinding.increaseLevel) then
			ECC.lastSpeedLevel = ECC.currentSpeedLevel;
			ECC.currentSpeedLevel = math.min(ECC.currentSpeedLevel+1, ECC.maxSpeedLevel);
		end;
		if InputBinding.hasEvent(InputBinding.decreaseLevel) then
			ECC.lastSpeedLevel = ECC.currentSpeedLevel;
			ECC.currentSpeedLevel = math.max(ECC.currentSpeedLevel-1, 1);
		end;
		if InputBinding.hasEvent(InputBinding.activateSpeedLevel) then
			ECC.speedLevelActivated = not ECC.speedLevelActivated;
		end;
		if ECC.speedLevelActivated and ECC.currentSpeedLevel ~= ECC.lastSpeedLevel then
			local newSpeed = ((self.motor.maxForwardSpeed*3.6)/ECC.maxSpeedLevel)*ECC.currentSpeedLevel;
			self:setCruiseControlMaxSpeed(newSpeed);
			ECC.lastSpeedLevel = ECC.currentSpeedLevel;
		end;
		if ECC.speedLevelActivated and g_currentMission.showVehicleInfo and g_currentMission.showHudEnv and g_currentMission.renderTime then
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(0.9, 0.9, 0.9, 0.9);
			renderText(1, 0, 0.015, g_i18n:getText("speedLevel")..ECC.currentSpeedLevel); --"Fahrstufe: " .. ECC.currentSpeedLevel
		end;
	end;
end;

Drivable.update = function(self, dt)
	drivable_update(self, dt);
	ECCFunction(self, dt);
end;